<?php

declare(strict_types=1);

namespace Dedi\SyliusMarketingPlugin\Extractor;

use Pagerfanta\Pagerfanta;
use Sonata\BlockBundle\Event\BlockEvent;
use Symfony\Contracts\EventDispatcher\Event;

class RequestProductExtractor implements RequestProductExtractorInterface
{
    public function extract(Event $event): array
    {
        if (!$event instanceof BlockEvent) {
            return [];
        }

        $settings = $event->getSettings();

        $products = [];
        if (isset($settings['products']) && $settings['products'] instanceof Pagerfanta) {
            $products = (array) $settings['products']->getCurrentPageResults();
        }

        return $products;
    }
}
