<?php

declare(strict_types=1);

namespace Dedi\SyliusMarketingPlugin\Provider;

use Sylius\Component\Channel\Context\ChannelContextInterface;

class GoogleTagIdProvider implements GoogleTagIdProviderInterface
{
    private ChannelContextInterface $channelContext;
    private ?string $defaultId = null;
    private ?array $channelsIds = null;
    public function __construct(ChannelContextInterface $channelContext, ?string $defaultId = null, ?array $channelsIds = null)
    {
        $this->channelContext = $channelContext;
        $this->defaultId = $defaultId;
        $this->channelsIds = $channelsIds;
    }
    public function provide(): ?string
    {
        if (is_array($this->channelsIds)) {
            foreach ($this->channelsIds as $channelCode => $id) {
                if ($this->channelContext->getChannel()->getCode() === $channelCode) {
                    return $id;
                }
            }
        }

        return $this->defaultId;
    }
}
